/*
 * Copyright (C) 2005, Edmundo Albuquerque de Souza e Silva.
 *
 * This file may be distributed under the terms of the Q Public License
 * as defined by Trolltech AS of Norway and appearing in the file
 * LICENSE.QPL included in the packaging of this file.
 *
 * THIS FILE IS PROVIDED AS IS WITH NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

%{
#include "vvserverconf_yacc.h"

#include <string.h>

extern int n_lines;
%}

ID      [_a-zA-Z]+[0-9]*
SPACE   [ \t]
LINE    [\n]
DIGIT   [0-9]
INTEGER {DIGIT}+
OCTET   {DIGIT}{1,3}
IPADDR  {OCTET}"."{OCTET}"."{OCTET}"."{OCTET}
STRING  \".*\"
COMMENT ("#".*\n)|("//".*\n)|("/*"(.|\n)*"*/")
%%
{COMMENT}   { }
{SPACE}     { }
{LINE}      { n_lines++; }
{IPADDR}    { return (TK_IPADDR); }
{INTEGER}   { yylval = strdup( yytext );
              return (TK_INTEGER); }
{STRING}    { return (TK_STRING); }
"="         { return (TK_EQ); }
"."         { return (TK_DOT); }
":"         { return (TK_COLON); }
"::"        { return (TK_DOUBLE_COLON); }
true        { return (TK_TRUE); }
false       { return (TK_FALSE); }
{ID}        { return (TK_ID); }
<<EOF>>     { yyterminate(); }
%%
