/*
 * Copyright (C) 2005, Edmundo Albuquerque de Souza e Silva.
 *
 * This file may be distributed under the terms of the Q Public License
 * as defined by Trolltech AS of Norway and appearing in the file
 * LICENSE.QPL included in the packaging of this file.
 *
 * THIS FILE IS PROVIDED AS IS WITH NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

#include "vvCodecs.h"
#include "mix.h"
#include "conversion_table.h"

void mix( unsigned char *mixedAudio, unsigned char *newAudio, int num )
{
    int i;
    short *orig, *dest;
    float temporary;

    orig = (short *)newAudio;
    dest = (short *)mixedAudio;
    for( i = 0; i < PCMDATASAMPLES; i++ )
    {
       temporary  = (float)dest[ i ] * (num - 1.0) / num;
       temporary += (float)orig[ i ] / num;

       dest[ i ]  = (short)temporary;
    }
}
