/*
 * Copyright (C) 2005, Edmundo Albuquerque de Souza e Silva.
 *
 * This file may be distributed under the terms of the Q Public License
 * as defined by Trolltech AS of Norway and appearing in the file
 * LICENSE.QPL included in the packaging of this file.
 *
 * THIS FILE IS PROVIDED AS IS WITH NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */
 
#ifndef __NET_H__
#define __NET_H__

#include "Packets.h"

/*  data-packet flags   */
#define SILENCE          1
#define REDUN_S0         2

#define TYPE_MASK        0x0F
#define UNKNOWN_PACKET   0
#define DATA_PACKET      5

#define FLAGS_MASK       0xF0
#define WITH_FEC         0x80

#define CODEC_NONE       0
#define CODEC_GSM        1
#define MAXCODEC         2

/*     Connection status      */
#define NOT_CONNECTED          0
#define SYN_SENT               1
#define SYN_RECV               2
#define ESTABLISHED            3
#define WAITING_RESPONSE       4

#define MAXPCKTSIZE     2048

/* Control Packets */
class VVControlPacket : public ControlPacket
{
    public:
            enum Type { UnknownPacket = 0, StartPacket = 1, EndPacket = 2,
                        BusyPacket = 3, StatPacket = 4,
                        TalkPacket = 6, SilPacket = 7, UserPacket = 8,
                        StatusPacket = 9, CallPacket = 10 };
};

class StartPacket : public VVControlPacket
{
   public:
            char username[ 80 ];
            char hostname[ 80 ];
            char codec;
};

class EndPacket : public VVControlPacket
{
};

class BusyPacket : public VVControlPacket
{
};

class TalkPacket : public VVControlPacket
{
};

class SilPacket : public VVControlPacket
{
    public:
            char flags;
};

class UserPacket : public VVControlPacket
{
    public:
            int codec;
            int redun;
            int silenceUser;
};

class StatPacket : public VVControlPacket
{
    public:
            STATS stats;
};

class StatusPacket : public VVControlPacket
{
};

/************/
typedef struct DATA_HEADER_TAG
{
    char          type;
    char          codec;
    char          flags;
    unsigned long seqNumber;
} *PDATAHEADER, DATAHEADER;

typedef struct DATA_PACKET_TAG
{
    DATAHEADER header;
    unsigned char audiosample[ PCMDATASIZE ];
} *PDATAPCKT, DATAPCKT;

#endif
