/*
 * Copyright (C) 2005, Edmundo Albuquerque de Souza e Silva.
 *
 * This file may be distributed under the terms of the Q Public License
 * as defined by Trolltech AS of Norway and appearing in the file
 * LICENSE.QPL included in the packaging of this file.
 *
 * THIS FILE IS PROVIDED AS IS WITH NO WARRANTY OF ANY KIND, INCLUDING
 * THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

#ifndef __VVCODECS_H__
#define __VVCODECS_H__

extern "C"
{
#include <gsm.h>
#include <speex/speex.h>
};

#define MODE_DECODER       true
#define MODE_ENCODER       false

#define CODEC_NONE        0
#define CODEC_GSM         1
#define CODEC_SPEEX       2
#define CODEC_MULAW       3
#define CODEC_SPEEX_0  0x00
#define CODEC_SPEEX_1  0x10
#define CODEC_SPEEX_2  0x20
#define CODEC_SPEEX_3  0x30
#define CODEC_SPEEX_4  0x40
#define CODEC_SPEEX_5  0x50
#define CODEC_SPEEX_6  0x60
#define CODEC_SPEEX_7  0x70
#define CODEC_SPEEX_8  0x80
#define CODEC_SPEEX_9  0x90
#define CODEC_SPEEX_10 0xA0

#define PCMDATASIZE     320
#define PCMDATASAMPLES  160
#define MULAWDATASIZE   160
#define GSMDATASIZE      33

typedef struct AUDIO_SPEEX_TAG
{
    void     *state;
    SpeexBits bits;
} AUDIO_SPEEX;

class vvCodecs
{
    private:
        bool          mode;
        gsm           hgsm;
        AUDIO_SPEEX   speex;
        unsigned char lastCodec;
        static int    speexSizes[];

    public:
        vvCodecs( bool mod );
        ~vvCodecs();
        int encode( char *, unsigned char, char * );
        int decode( char *, unsigned char, char * );
        static int getSize( unsigned char );
        static int getFromSize( int );
};

#endif
